#include <SPI.h>
#include <Adafruit_GFX.h>
#include <Max72xxPanel.h>

int pinCS = 10; // CS wird an diesem pin angeschlossen, DIN an MOSI (das ist PIN 11) und CLK an SCK (das ist PIN 113 )
int numberOfHorizontalDisplays = 4; //Anzahl der 8x8- Displays in einer Reihe
int numberOfVerticalDisplays = 1; //Anzahl der Reihen

Max72xxPanel matrix = Max72xxPanel(pinCS, numberOfHorizontalDisplays, numberOfVerticalDisplays);

String tape = "Mathias Dahlke (DJ9MD)";
int wait = 200; // Warten zwischen den Takten in Milisekunden

int spacer = 1;
int width = 5 + spacer; //Der Font ist 5x5 Pixel groß und der Anstand ist ein Pixel

void setup() {

  matrix.setIntensity(2); // Für die Helligkeit (0 = Minimum...15 = Maximum)

// Hier werden die Anordnungen der einzelnen 8x8- Anzeigen angegeben
// Die einzelnen Module werden beginnend mit dem Modul, das direkt am
// ARDUINO angeschlossen ist (0) von links nach rechts und von oben nach unten
// durchnumeriert. Das erste Modul der ersten Reihe hat die Koordinate 0, 0
// das erste Modul der zweiten Reihe ist 0, 1.
//
// Santax: .setPosition(Modulnummer, Spaltennummer, Zeilennummer)

  matrix.setPosition(3, 0, 0); // 
  matrix.setPosition(2, 1, 0); // 
  matrix.setPosition(1, 2, 0); // 
  matrix.setPosition(0, 3, 0); // 

// Mit dem Befehl .setRotation(Modulnummer, Rotation) 
// lässt sich die Orientierung des jeweiligen Moduls definieren. Rotation 
// ist die Rotation in 90°- Schritten, wobei "0" null Grad und "3" 270 
// Grad darstellen.

  matrix.setRotation(0, 1);    
  matrix.setRotation(1, 1);    
  matrix.setRotation(2, 1);    
  matrix.setRotation(3, 1); 
}

void loop() {

  for ( int i = 0 ; i < width * tape.length() + matrix.width() - 1 - spacer; i++ ) {

    matrix.fillScreen(LOW);

    int letter = i / width;
    int x = (matrix.width() - 1) - i % width;
    int y = (matrix.height() - 8) / 2; // center the text vertically

    while ( x + width - spacer >= 0 && letter >= 0 ) {
      if ( letter < tape.length() ) {
        matrix.drawChar(x, y, tape[letter], HIGH, LOW, 1);
      }

      letter--;
      x -= width;
    }

    matrix.write(); // Send bitmap to display

    delay(wait);
  }
}

